# -*- coding: utf-8 -*-
"""
Created on Thu Sep 29 15:29:37 2022



考虑使用类来管理配置参数













2022-10-10 添加 输出文件名返回
计算 md5 值
2) 自动 查询目录更新

2022-10-21  上位机修改帧
## 这一版本 出现 matplotlib 画图吃掉内存的情况；
## 需要清理画图 内容或在其他别的方法。
## 将画图程序改为类  固定画图窗口大小 
## /home/chashan/programes/mwrscode
# 2022-10-28 22 个数据包出现问题
#  2022-11-18 修正
## 数据包中考虑跨天的时间
## 时间统一使用 北京时间的偏移量减去 8*3600 秒
## 其它应用 通过判断时间为 负值 使得观测时间天数加1

2022-11-23 修改时间 间隔冲突,预留出单个bin包处理测试



2023-05-27 修改bin 转 fits 使用 uint16 造成的 溢出


2023-06-62 修正结束时间的判定  1413 行
2024-01-16 按子午新要求修改过文本说明字符串
2024-03-07 STP -> 05M


@author: wangbing
"""


import matplotlib.pyplot as plt
import matplotlib.dates as mdates
from matplotlib.ticker import MultipleLocator

import os
from fnmatch import fnmatch
import time
import datetime
from astropy.io import fits
import numpy as np
import rebin
import hashlib


import sys


#### use font set 
#plt.rcParams['font.family']='sans-serif'
#plt.rcParams['font.sans-serif']=['SimHei']
#plt.rcParams['font.sans-serif']=['Arial']


setNfile=1
if len(sys.argv)>1:
    setNfile=int( sys.argv[1])




startTime = time.time()
#############################3
#### 判断端口是否开放
def socketporttest( setip , portnum ) :
    import socket
    netv = 0
    try :
        cons = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        cons.settimeout(10) ## 设置
        cons.connect( ( setip, portnum ) )
        netv = 1
    except :
        print('cant connect ' + setip )
    return netv

## 使用 os.system  + ping 
def ipcanping( setip ):
    #### centos7 linux 系统测试
    netv = 0
    comss = 'ping -c 1 ' + setip #+ '-I 172.63.11.11'
    try :
         sss = os.system( comss ) 
         if sss == 0:
             netv = 1
    except :
         print('server ' + setip + ' is offline !!!')
             
    return netv








## fn 含有路径，如果不含路径 搜索当前目录
def file_search_suffix(target_dir, target_suffix="fit"):
    ## 会搜索子文件夹中的数据
    find_res = []
    target_suffix_dot = "." + target_suffix
    walk_generator = os.walk(target_dir)
    for root_path, dirs, files in walk_generator:
        if len(files) < 1:
            continue
        for file in files:
            file_name, suffix_name = os.path.splitext(file)
            if suffix_name == target_suffix_dot:
                find_res.append(os.path.join(root_path, file))
    find_res.sort()
    return find_res

def file_search( fn , subdir = 0 ) :
    findfiles = []
    allv = 0
    if subdir == 1 :
       allv = 1
    ## split dir  and base name
    target_dir, infname = os.path.split( fn )
    if len(target_dir) == 0 :
        target_dir = './'
    ## check dir
    walk_generator = os.walk(target_dir)
    for root_path, dirs, files in walk_generator :
        if allv ==1 :
            if len(files) < 1:
                continue
            for file in files:
               if fnmatch( file, infname ) :
                  findfiles.append(os.path.join(root_path, file ))
        else :
            if  fnmatch( root_path, target_dir ) :
                if len(files) < 1:
                   continue
                for file in files:
                   if fnmatch( file, infname ) :
                      findfiles.append(os.path.join(root_path, file ))

    findfiles.sort()
    return findfiles

def datefromfname(fn) :
    # fn is a string of path, 
    # return [year,month,day]= [2022,9,28]
    target_dir, infname = os.path.split( fn )
    dated = [int(infname[14:18]),int(infname[18:20]),int(infname[20:22])]
    return dated



## 从fname 文件中 查找文件头, 
def getheadn(fname , testsize ) :
    ## 查找帧头位置 返还zheng'xing
    fp = open(fname, 'rb')
    bb = fp.read(testsize + 1 )
    fp.close()
    if len(bb) < testsize :
        print(' data less one frame !')
        return -1
## =============================================        
    for iijj in range( testsize ) :
       if bb[iijj] == 90 :
          if bb[int(iijj+1)] == 60 :
              break
   
    if iijj == ( testsize - 1 ) :
        print('dont,find head in one frame')
        iijj = -1
    return iijj

### 从指定位置进行向后查找
def getheadnwhere(fname , testsize, nwhere ) :
    ## 查找帧头位置 返还zheng'xing
    ## 修改找不到帧头的情况 2022-10-09
    fp = open(fname, 'rb')
    fp.seek(nwhere)
    bb = fp.read(testsize)
    fp.close()
    havehead = 0
    for iijj in range( testsize -1  ) :
       if bb[iijj] == 90 :
          if bb[ int(iijj+1) ] == 60 :
              havehead = 1
              break
   
    if havehead == 0 :
        print('dont,find head')
        return -1
    return iijj + nwhere


def getnBdata(fname ,  gsize,  nwhere ) :
    ## 到指定位置
    fp = open(fname, 'rb')
    fp.seek( nwhere )
    bb = fp.read( gsize )
    fp.close()   
    return bb

# ########outputdat
### creat fits file name
def creatDatFile(ttx, ffx, data, outdir,R1stat, R2stat, ssobj, datedd, BJT2UTC):
    nows = datetime.datetime.now()
    nowsutc = nows - datetime.timedelta(hours=8)
    ttxx = ttx - BJT2UTC
    datetstart = datetime.datetime(datedd[0],datedd[1],datedd[2],0,0,0)
    s2 = datetstart + datetime.timedelta( seconds = ttxx[0] )
    s3 = datetstart + datetime.timedelta( seconds = ttxx[-1]  )
        
    ntime = len(ttxx)    
    nff = len(ffx)    
    # datname = outdir + 'OROCH_MWRS01_SRSP_L0_05M_'+ s2.strftime('%Y%m%d%H%M%S') + '_V01.01.dat'
    # datname = outdir + 'OROCH_MWRS01_SRSP_L0_STP_'+ s2.strftime('%Y%m%d%H%M%S') + '_V01.01.dat'
    # 2024-03-07 修改 STP -> 05M
    datname = outdir + 'OROCH_MWRS01_SRSP_L0_05M_'+ s2.strftime('%Y%m%d%H%M%S') + '_V01.01.dat'
    
    
    
    insertss = []
    insertss.append('#DataName: Raw Solar Radio Spectrum')
    insertss.append('#CopyRight: Chinese Meridian Project')
    insertss.append('#Station: OROCH(122.31E, 36.84N, 53m)')
    insertss.append('#Instrument: Metric Wave Solar Radio Spectrometer')
    insertss.append('#Producer: ShanDong University')
    insertss.append('#FileCreateTime: ' + nowsutc.strftime('%Y-%m-%dT%H:%M:%S') + 'Z' )
    insertss.append('#DataLevel: L0')
    insertss.append('#DataVersion: V01.01')
    # insertss.append('DataStartTime: ' + s2.strftime('%Y-%m-%dT%H:%M:%S.') + '{:06.0f}'.format(( ttxx[0] - np.floor(ttxx[0]))* 1000000  ) )
    # insertss.append('DataEndTime: ' + s3.strftime('%Y-%m-%dT%H:%M:%S.') + '{:06.0f}'.format(( ttxx[-1] - np.floor(ttxx[-1]))* 1000000  ) )
    insertss.append('#DataStartTime: ' + s2.isoformat()[:-3] + 'Z' ) 
    insertss.append('#DataEndTime: ' + s3.isoformat()[:-3] + 'Z' )
    insertss.append('#QualityFlag: TBD')
    insertss.append('#ObsMode: NormalMode')
    insertss.append('#RecordNumber: {:<10d}'.format(ntime))
    insertss.append('#DeviceSpec: FreqRange=90~300MHz, FreqBegin=90.026855MHz, ')
    insertss.append('FreqResolution=0.076294MHz, Sensitivity=1SFU, DynamicRange>=60dB')
    insertss.append('#DeviceState: N')
    insertss.append('#ObsParameters: AccuTime= 0.838ms,  FreqNum= 2754')
    insertss.append('#Quantities: FFTVoltage(No unit)')
    insertss.append('#Object: '+ ssobj)
    insertss.append('#AdcParameters: SampleFreq=1.25Gsps, FFTNum=16K, Cumulative=64' )
    insertss.append('#NoiseState: ' + 'R1={:1d}, R2={:1d}'.format(R1stat, R2stat) )
    insertss.append('#amplitude: 0-65535')
    insertss.append('#---------------------------------------------------------------------')
    # insertss.append('END')
    
    strin=''
    for inss in insertss :
        strin = strin + inss + '\r\n' 
    
    strlength = len(strin) 
    bstrlength = strlength.to_bytes(2, byteorder='big')
    ### int.from_bytes(bb[4:6],byteorder='big', signed = False )
    ntlength = ntime.to_bytes(4, byteorder='big')
    nflength = nff.to_bytes(4, byteorder='big')
    startdatfileID = np.float64( 24 )
    try :
        fp = open(datname, mode= 'wb' )
        fp.write( strin.encode('utf-8') )
        fp.write( startdatfileID )
        fp.write( bstrlength )
        fp.write( ntlength )
        fp.write( nflength )
        # fp.write( data.astype('>f8') )
        # fp.write( ttxx.astype('>f8') )
        # fp.write( ffx.astype('>f8') )
        fp.write( data )
        fp.write( ttxx  )
        fp.write( ffx )
        
        fp.close()
    except:
        print('write dat file failed ')
        return 0
    
    
    return datname
    # ##############################################################################################    
    
def callibrationDon(  dataori   ) :
   ### 考虑校准
    
    Caldata = 1.0 * dataori * dataori
  
    return Caldata
    
### namefits = creatFitsFile(ttxx, ffxx,  ZZ , df, et, datedd,  obsstate, outdirfits, BJT2UTC )   
### creat fits file
def creatFitsFile(ttx, frequency, dataRL, df, et, datedd,  obsstate,  outdir, BJT2UTC):
    tts = ttx - BJT2UTC
    nfreq = len( frequency )
    ### time shift by seconds from this day 00:00:00
    nt = len(tts)
    nows = datetime.datetime.now()
    datetstart = datetime.datetime(datedd[0],datedd[1],datedd[2],0,0,0)
    s2 = datetstart + datetime.timedelta( seconds = tts[0] )
    s3 = datetstart + datetime.timedelta( seconds = tts[-1] )
    
    nowsutc = nows - datetime.timedelta( hours = 8 )
    creattimes = nowsutc.isoformat()[:-3] + 'Z'
    obstimes = s2.isoformat()[:-3] + 'Z'
    startTs = s2.isoformat()[:-3] + 'Z'
    endTs = s3.isoformat()[:-3] + 'Z'
    ttform = str(nt ) + 'D'
    ffform = str(nfreq ) + 'D'     
    ### creat fits file na me
    # fitsname = outdir + 'OROCH_MWRS01_SRSP_L1_05M_'+ s2.strftime('%Y%m%d%H%M%S') + '_V01.01.fits'
    # fitsname = outdir + 'OROCH_MWRS01_SRSP_L1_STP_'+ s2.strftime('%Y%m%d%H%M%S') + '_V01.01.fits'
    #  2024-03-07 STP -> 05M
    fitsname = outdir + 'OROCH_MWRS01_SRSP_L1_05M_'+ s2.strftime('%Y%m%d%H%M%S') + '_V01.01.fits'
    
    
    if os.path.exists( fitsname ) :
       os.remove(fitsname)
    
    #OROCH_MWRSnn_SRSP_L1_05M
    ### creat Primary header 
    headerm = fits.Header()
    ##### 添加 主表的 关键字信息 关键字大小写不敏感
    ### 需要变化的关键字 
    ### 1 保留关键字===============
    #headerm['FILENAME'] = fitsname
    headerm['ORIGIN'] = 'Chinese Meridian Project for Space Environment Monitoring'
    headerm['TELESCOP'] = ('MWRS','Metric Wave Solar Radio Spectrometer')
    headerm['OBJECT'] =('SUN','object description')
    headerm['DATE'] = creattimes
    headerm['DATE-OBS'] = obstimes
    headerm['BUNIT'] = ('SolarFluxUnit(SFU)','quantities and units')
    headerm['COMMENT'] ='The voltage signals after FFT transmformation, stored as 3-dimesion data array.'
    
    
    
    ### 2 自定义通用关键字==========================================================
    headerm['DEV_LOC'] = ('OROCH', 'location of the telescope')
    headerm['DEV_LON'] = (122.31,'[degree] east longitude')
    headerm['DEV_LAT'] = (36.84,'[degree] North latitude')
    headerm['DEV_ALT'] = (53.00,'[m] altitude,height above see level')
    headerm['CONTENT'] ='Solar Radio Spectrum'
    # headerm['CONTACT'] = 'ShiWei Feng (winfeng@sdu.edu.cn)'
    headerm['CONTACT'] = 'Zhao Wu (wuzhao@sdu.edu.cn)'
    headerm['TIMESYS'] = 'UTC' 
    headerm['VERSION'] = ('V01.01','build version of the file')
    headerm['PRODUCER'] = ('OROCH',' at WeiHai operated by ShanDong University')
    headerm['DATE_BEG'] = startTs
    headerm['DATE_END'] = endTs
    headerm['OBS_MODE'] = ('NormalMode','operation mode of the device')
    headerm['DATA_LEV'] = ('L1','data level')
    
    ### 3 辅助关键字==========================================================
    
    headerm['OP_PARAM'] = ('ADC: 1.25Gsps, FFT length: 16x1024, Average: 64', '')
    headerm['DEV_SPEC'] = ('Sensitivity=1SFU; DynamicRange>=60dB', 'device specifications')
    headerm['DEV_STAT'] = ('N','state of the device (N/V)')
    headerm['QUAL_FLG'] = ('TBD', 'data quality control information') 
    headerm['POLARIZA'] = ('RCP and LCP', 'polarization types') 
    headerm['FREQ']     = ('90~300 MHz', 'frequency range of observation') 
    headerm['FREQBEG']  = ('{:.6f}'.format(frequency[0]), '[MHz] begin of frequency') 
    headerm['FREQRESO'] = ('{:.6f}'.format(df), '[MHz] frequency resolution') 
    headerm['ACCU_TM']  =  ('{:.3f}'.format(et*1000), '[ms] accumulated time')
    headerm['CAL_TEMP'] = ('T','whether calibrated by temperature')
    #### === end main head set ==========================================
    
    
    ### make HDU
    mainHDU = fits.PrimaryHDU( header=headerm, data = dataRL )
    ###  注意字节序
    coltt = fits.Column(name='Time', format= ttform  )
    colfreq = fits.Column(name='frequency', format=ffform )
    coldefs = fits.ColDefs([coltt, colfreq])
    
    bintable_hdu =  fits.BinTableHDU.from_columns( coldefs, nrows= 1 )
    bintable_hdu.data['Time']= tts
    bintable_hdu.data['frequency']= frequency
    bintable_hdu.header['Time']  =  'shift seconds of the day' 
    bintable_hdu.header['freq']  =  'observation frequency MHz' 
    
    
    try :
    ##### creat HDUlist  include one binarytable consisted one row
        hdul = fits.HDUList([mainHDU, bintable_hdu])
        
        ###### write and close =====
        hdul.writeto( fitsname )
        hdul.close()
    except :
        print('write fits file failed !')
        return 0
    # finfo = os.stat(fitsname)
    # filesize0 = finfo.st_size
    return fitsname
###===============================================
def getdatatopart( dataRLn ):
    
    
    data2f=0
    
    
    return data2f

def plot_set_parar():
    
    
    plotpraSet=0
    
    
    return plotpraSet


class figaxplotset():
    #### 色表设置
  def  __init__(self,scalestyle = 'log10',minv=1.50, maxv=5.0 ):
    import matplotlib.cm as mplcm
    jcmap = mplcm.get_cmap("jet").copy()
    jcmap.set_over(color = 'w')

    setfontsize = 10.0

    ### 图片大小设置
    wx = 1200
    qx = 80
    hx = 120
    hy = 230
    uy = 80
    dy = 80
    ddy = 40
    widthh = qx + wx + hx
    height = dy + hy + ddy + hy + ddy + hy + uy
    wxfig =int( wx * 1)
    hyfig =int( hy * 1)
    
    
    
    
    ####
    pos1 =[0.0,0.0,1.0,1.0]
    pos1[0] = (qx + 0.0) / widthh
    pos1[1] = (dy + hy + ddy + hy + ddy + 0.0 ) / height
    pos1[2] = (wx + 0.0) / widthh
    pos1[3] = (hy + 0.0) / height
    
    pos2 =[0.0,0.0,1.0,1.0]
    pos2[0] = (qx + 0.0) / widthh
    pos2[1] = (dy + hy + ddy  ) / height
    pos2[2] = (wx + 0.0) / widthh
    pos2[3] = (hy + 0.0) / height
    
    
    pos3 =[0.0,0.0,1.0,1.0]
    pos3[0] = (qx + 0.0) / widthh
    pos3[1] = (dy + 0.0 ) / height
    pos3[2] = (wx + 0.0) / widthh
    pos3[3] = (hy + 0.0) / height
    
    posbar =[0.0,0.0,1.0,1.0]
    posbar[0] = (qx + wx + 20.0) / widthh
    posbar[1] = (dy + hy + ddy ) / height
    posbar[2] = (70.0) / widthh
    posbar[3] = (hy + ddy + hy) / height
    
    fig, ax = plt.subplots(3, 1, sharex=True,figsize=(widthh/100.0,height/100.0),dpi=100)
    #  进入画图部分
    nows=datetime.datetime.now()
    months = nows.strftime('%b')
    datess = nows.strftime('%d') + ' ' + months.upper() + ' ' + nows.strftime('%Y')
    titles = 'Quick-look of solar radio spectrum (SRSQ) OROCH (122.31E, 36.84N) '+ datess 
    fig.suptitle(titles,fontsize=10.0)
    ttxx = np.arange( wxfig )
    ffxx = np.arange( hyfig )
    xx, yy = np.meshgrid(ttxx,ffxx)               
    fr = [ffxx[0],ffxx[-1]]     
    xr = [ttxx[0],ttxx[-1]]     
    datetstart0 = datetime.datetime(2022, 10, 21, 0,0,0)                   
    s2 = datetstart0 + datetime.timedelta( seconds = np.double( ttxx[0] ) )
    s3 = datetstart0 + datetime.timedelta( seconds = np.double( ttxx[-1] ) )
    Z1 = xx*0.0 + 10
    Z0 = Z1.copy()
     
    #### plot Right or first  
    ax1 = ax[0] 
    ax1.set_position( pos1 ) 
                     
    ax1.set_ylabel('Frequency (MHz)',fontsize = setfontsize )
    ax1.set_title( 'RCP',fontsize = setfontsize  )
    ax1.set_xlim([s2, s3])
    ax1.set_ylim( fr )
                       #ax.xticks(rotation=70)
                       
                       
    ax1.xaxis.set_major_formatter( mdates.DateFormatter('%H:%M:%S'))
    # ax1.xaxis.set_minor_locator(mdates.MinuteLocator())
    ax1.xaxis.set_minor_locator(mdates.SecondLocator())
    ax1.yaxis.set_minor_locator(MultipleLocator(10))
    ax1.tick_params(direction='out', labelsize=10.0,left=True, right=True)
    
    #ax1.tick_params(direction='out', labelsize=10.0,length=6, width=2, colors='b',
    #               grid_color='b',   left=True, right=True)
    
    ax1in1 = ax1.inset_axes([0.0, 0.0, 1, 1])


    psm1 = ax1in1.pcolormesh(xx, yy, Z0, vmin=minv, vmax=maxv,cmap =jcmap, rasterized=True)
    ax1in1.axis('off')
    bar1 = fig.colorbar(psm1,ax=ax1in1)
    bar1.ax.text(1, maxv+(maxv-minv)/100, 'dB') 
    bar1.ax.set_position(posbar)
    
    
    
    ax2 = ax[1] 
    ax2.set_position( pos2 )   
    ax2.set_ylabel('Frequency (MHz)',fontsize = setfontsize )
    ax2.set_title( 'LCP',fontsize = setfontsize  ) 
    ax2.set_xlim([s2, s3])
    ax2.set_ylim( fr )
    ax2.xaxis.set_major_formatter( mdates.DateFormatter('%H:%M:%S'))
    # ax2.xaxis.set_minor_locator(mdates.MinuteLocator())
    ax2.xaxis.set_minor_locator(mdates.SecondLocator())
    ax2.yaxis.set_minor_locator(MultipleLocator(10))
    ax2.tick_params(direction='out', labelsize=10.0,left=True, right=True)
    
    ax1in2 = ax2.inset_axes([0.0, 0.0, 1, 1])
    psm2 = ax1in2.pcolormesh(xx, yy, Z1, vmin=minv, vmax=maxv, cmap =jcmap, rasterized=True)
    ax1in2.axis('off')
    
    ### 流量图
    ax3 = ax[2] 
    ax3.set_position( pos3 )   
    ax3.set_title( 'Solar Radio Flux@245' ,fontsize = setfontsize) 
    ax3.set_xlim([s2, s3])
    ax3.set_ylabel('Flux (SFU)',fontsize = setfontsize )
    ax3.set_xlabel('Time (UT)',fontsize = setfontsize)
    
    ax3.xaxis.set_major_formatter( mdates.DateFormatter('%H:%M:%S'))
    # ax3.xaxis.set_minor_locator(mdates.MinuteLocator())
    ax3.xaxis.set_minor_locator(mdates.SecondLocator())
    ax3.tick_params(direction='out', labelsize=10.0,left=True, right=True)
    ax1in3 = ax3.inset_axes([0.0, 0.0, 1, 1])
    
    hlcp = ax1in3.plot( ttxx, Z1[50,:],  'b',  label = 'LCP')
    hrcp = ax1in3.plot( ttxx, Z1[100,:], 'r',  label = 'RCP')
    
    ax1in3.set_xlim( xr )
    ax1in3.axis('off')
    ax1in3.legend( loc = 'upper right')
    ax3.set_ylim( ax1in3.get_ylim()) 
    
    
    # axx = (ax1,ax2,ax3,ax1in1,ax1in2, ax1in3)
    # barax = ( bar1)
    # psmx = [psm1, psm2]
    self.fig = fig
    # self.axx = axx
    self.ax1 = ax1
    self.ax2 = ax2
    self.ax3 = ax3
    
    self.ax1in1 = ax1in1
    self.ax1in2 = ax1in2
    self.ax1in3 = ax1in3

    self.wx = wx
    self.hy = hy
    self.pos1=pos1
    self.pos2=pos2
    self.pos3=pos3
    self.posbar=posbar
    self.jcmap = jcmap
    self.bar =  bar1
    self.psm1 = psm1
    self.psm2 = psm2
    self.hlcp = hlcp
    self.hrcp = hrcp
    
    self.scalestyle = scalestyle
    self.minv=minv
    self.maxv=maxv
    self.setfontsize = setfontsize
    self.wxfig = int(wxfig)
    self.hyfig = int( hyfig) 
    
    # return fig, axx, wx,hy, pos1,pos2,pos3, posbar, jcmap, barax, psmx



## jpg creat
def creatJPGfile(figset, ttts, freqx, caldata , df, et, datedd,  obsstate, outdir, BJT2UTC ) :
   #### 制作快事预览图
    ttt = ttts - BJT2UTC
    ### time shift by seconds from this day 00:00:00
    nows = datetime.datetime.now()
    datetstart = datetime.datetime(datedd[0],datedd[1],datedd[2],0,0,0)
    s2 = datetstart + datetime.timedelta( seconds = ttt[0] )
    s3 = datetstart + datetime.timedelta( seconds = ttt[-1] )
    

    ### creat fits file name  考虑输出 目录   outdir
    ### 2023-07-24 修改文件后缀jpg 为 JPG
    ## jpgname =outdir +  'OROCH_MWRS01_SRSQ_L1Q_STP_'+ s2.strftime('%Y%m%d%H%M%S') + '_V01.01.JPG'
    ## 2024-03-07 STP -> 05M
    jpgname =outdir +  'OROCH_MWRS01_SRSQ_L1Q_05M_'+ s2.strftime('%Y%m%d%H%M%S') + '_V01.01.JPG'
    
    ### 画图参数设置
    fr = [ freqx[0], freqx[-1] ]
    xr = [ttt[0], ttt[-1] ]

    
   # 从数据 中抽取 相应的数据
    nt = len(ttt)
    nff = len(freqx)
    #### 使用方法一 rebin 图像
    ### 保证每次图像的 大小一致
    if 1 == 1 :
        getdt = 1
        getdff = 1
        
        ## 仅仅考虑 freqx 为 2754 个频率点
        if nt > figset.wxfig :
            getdt = int( np.round( nt / figset.wx  ) )
            # ntstart = int(  getdt / 2 )
            # ttxx = ttt[ntstart::getdt]
            ttxx = rebin.rebin( ttt,  factor=( getdt,) , func= np.mean )
            nt = len(ttxx)

        if nff > figset.hyfig :
            getdff = int( np.round(  nff / figset.hy ) )
            # nffstart = getdff // 2 
            # ffxx = freqx[nffstart::getdff]
            ffxx = rebin.rebin( freqx,  factor=( getdff,) , func= np.mean )
            nff = len(ffxx)
        # ZZ = caldata[:, 0::getdff, 0::getdt]
        
        
        ZZ = rebin.rebin( caldata,  factor=(1, getdff, getdt)  )
        ##### 2024-01-12添加抽取数据 转为 fits
        df = ffxx[1] - ffxx[0]
        et = ttxx[1] - ttxx[0]
        outdirfits = outdir[:-4] + 'fits/'
        namefits = creatFitsFile(ttxx, ffxx,  ZZ , df, et, datedd,  obsstate, outdirfits, 0.0 )

        # ### 先考虑 频率情况
        # ZZrebin = rebin.rebin( caldata,  factor=(1, getdff, getdt)  )
        # if nff == 2754 :
        #    ZZ = np.zeros( (2, int(figset.hyfig), nt ) )
        #    ZZ[:,0:229,:] = ZZrebin
           
        # if nff == 8180 :
        #     ZZ = np.zeros( (2, int(figset.hyfig), nt ) )
        #     ZZ[:,0:229,:] = ZZrebin
        
        
# ####--------------------------------------------------------------------
        nt0 = nt
        if nt > figset.wxfig :
            # difnt = int( nt - figset.wxfig)
            ttxx = ttxx[ 0 : int( figset.wxfig)]
            nt = len(ttxx)
            ZZ = ZZ[:, :, 0: nt]
        ### 考虑时间 轴偏小的情况    
        if nt < figset.wxfig :
            difnt = int( figset.wxfig - nt)
            ttxx = np.hstack( (ttxx, ttt[int( nt * getdt ):int( nt * getdt + difnt)] ) )
            ZZx = np.zeros( (2, nff, int(figset.wxfig) ) )
            ZZx[:,:,0:nt] = ZZ
            ZZx[:,:,nt:int(figset.wxfig)] = rebin.rebin( caldata[:,:,int( nt * getdt  ):int( nt * getdt + difnt)],  factor=(1, getdff, 1) )
            ZZ = ZZx.copy()
            nt = len(ttxx)
            
        if nff > figset.hyfig :
            ffxx = ffxx[0: int( figset.hyfig)]
            nff = len(ffxx)
            ZZ = ZZ[:,0: nff, :] 
         #####################################################################   

        if nff < figset.hyfig :
            difnf = int( figset.hyfig - nff)
            ffxx = np.hstack( (ffxx, freqx[int( nff * getdff ): int( nff * getdff + difnf )] ) )
            ZZx = np.zeros( (2, int(figset.hyfig),  int(figset.wxfig) ) )
            ZZx[:,0:nff,:] = ZZ
            
            temp = rebin.rebin( caldata[:,int( nff * getdff ): int( nff * getdff + difnf ),:],  factor=(1, 1,  getdt)  )
            if nt0 > figset.wxfig :
               ZZx[:,nff:int(figset.hyfig),:] = temp[:,:,0: int( figset.wxfig)]
            if nt0 < figset.wxfig :
               ZZx[:,nff:int(figset.hyfig),0: nt0] = temp 
               ZZx[:,nff:int(figset.hyfig),nt0: nt]= caldata[:,int( nff * getdff ): int( nff * getdff + difnf ),int( nt0 * getdt  ):int( nt0 * getdt + difnt)]
            nff = len(ffxx)
            ZZ = ZZx.copy()
        
        
    
    if 2 == 0 :
        getdt = 1
        getdff = 1
        
        
        if nt > figset.wx :
            getdt = int( nt / figset.wx  )
            ntstart = int(  getdt / 2 )
            ttxx = ttt[ntstart::getdt]
            nt = len(ttxx)
        if nff > figset.hy :
            getdff = int(  nff / figset.hy )
            nffstart = getdff // 2 
            ffxx = freqx[nffstart::getdff]
            nff = len(ffxx)
        ZZ = caldata[:, nffstart::getdff, ntstart::getdt]
    

    index = np.where( freqx >= 245 )
    index245 = index[0][0]
    fluxL = np.reshape(  caldata[1, index245, :], ttt.shape )
    fluxR = np.reshape(  caldata[0, index245, :], ttt.shape )
    maxfluxlr = np.max( [ np.max(fluxL), np.max(fluxR)] )
    y3r = [0,1.0]
#### scale data  ================================
    
    ZZx = ZZ.copy() ### np.zeros_like( Z0 )
    if  figset.scalestyle == 'log10' :
       indexZ = np.where(ZZx < 1)
       if len(indexZ[0]) > 0 :
          ZZx[indexZ] = 1.0
       ZZs = np.log10( ZZx )
       Z0 = ZZs[0,:,:] 
       Z1 = ZZs[1,:,:] 
    else :
       Z0 = ZZx[0,:,:] 
       Z1 = ZZx[1,:,:]  
#######==============================================
#  进入画图部分
    months = s2.strftime('%b')
    datess = s2.strftime('%d') + ' ' + months.upper() + ' ' + s2.strftime('%Y')
    titles = 'Quick-look of solar radio spectrum (SRSQ) OROCH (122.31E, 36.84N) ' +  datess
    figset.fig.suptitle(titles,fontsize=10.0)
    xx, yy = np.meshgrid(ttxx,ffxx)               

    figset.ax1.set_xlim([s2, s3])
    figset.ax1.set_ylim( fr )
                       #ax.xticks(rotation=70)     
    figset.ax1.xaxis.set_major_formatter( mdates.DateFormatter('%H:%M:%S'))
    figset.ax1.xaxis.set_minor_locator(mdates.MinuteLocator())
    figset.ax1.yaxis.set_minor_locator(MultipleLocator(10))
    figset.ax1.tick_params(direction='out', labelsize=10.0,left=True, right=True)
    figset.psm1.set_array( Z0 )
    #ax1.tick_params(direction='out', labelsize=10.0,length=6, width=2, colors='b',
    #               grid_color='b',   left=True, right=True)
    # figset.ax1in1 = figset.ax1.inset_axes([0.0, 0.0, 1, 1])
    # figset.psm1 = figset.ax1in1.pcolormesh(xx, yy, Z0, vmin=figset.minv, vmax=figset.maxv,cmap =figset.jcmap, rasterized=True)
    # figset.ax1in1.axis('off')
    # figset.bar1 = figset.fig.colorbar(figset.psm1,ax=figset.ax1in1)
    # figset.bar1.ax.text(1, figset.maxv+(figset.maxv-figset.minv)/100, 'dB') 
    # figset.bar1.ax.set_position(figset.posbar)
    

    figset.ax2.set_xlim([s2, s3])
    figset.ax2.set_ylim( fr )
    figset.ax2.tick_params(direction='out', labelsize=10.0,left=True, right=True)
    figset.psm2.set_array( Z1 )
  
    
    ### 更新 流量图  ============================================
    figset.ax3.set_xlim([s2, s3])
    figset.ax3.tick_params(direction='out', labelsize=10.0,left=True, right=True)

    figset.hlcp[0].set_xdata(  ttt )
    figset.hlcp[0].set_ydata(  fluxL/maxfluxlr ) 
    figset.hrcp[0].set_xdata(  ttt  )
    figset.hrcp[0].set_ydata(  fluxR/maxfluxlr ) 
    
    ### 设置 坐标范围
    figset.ax1in3.set_xlim( xr )
    figset.ax1in3.set_ylim( y3r )
    figset.ax1in3.axis('off')
    figset.ax1in3.legend( loc = 'upper right')
    figset.ax3.set_ylim( figset.ax1in3.get_ylim()) 
    
    ### 保存下一张图片
    figset.fig.savefig(jpgname)
    nowsutc = datetime.datetime.now() - datetime.timedelta( hours=8 )

    fp = open(jpgname, mode='rb')
    bb = fp.read()
    fp.close()
    skipn  =  int.from_bytes(bb[4:6],byteorder='big', signed = False )
    
    
    insertss = []
    insertss.append('#DataName: Solar Radio Spectrum Quick-look Picture')
    insertss.append('#CopyRight: Chinese Meridian Project')
    insertss.append('#Station: OROCH(122.31E, 36.84N, 53m)')
    # insertss.append('Station:(OROCH(122.306°E,36.838°N,53m))')
    
    insertss.append('#Observotory: Metric Wave Solar Radio Spectrometer')
    insertss.append('#Producer: ShanDong University')
    insertss.append('#FileCreateTime: ' + nowsutc.strftime('%Y-%m-%dT%H:%M:%S')+'Z' )
    insertss.append('#DataLevel: L1Q')
    insertss.append('#DataVersion: V01.01')
    # insertss.append('DataStartTime: ' + s2.strftime('%Y-%m-%dT%H:%M:%S.') + '{:06.0f}'.format(( ttt[0] - np.floor(ttt[0]))* 1000000  ) )
    # insertss.append('DataEndTime: ' + s3.strftime('%Y-%m-%dT%H:%M:%S.') + '{:06.0f}'.format(( ttt[-1] - np.floor(ttt[-1]))* 1000000  ) )
    
    insertss.append('#DataStartTime: ' + s2.isoformat()[0:23] + 'Z' )
    insertss.append('#DataEndTime: '   + s3.isoformat()[0:23] + 'Z' )
    
    insertss.append('#ObsMode: NormalMode')
    insertss.append('#QualityFlag: TBD')
    insertss.append('#DeviceSpec: FreqRange=90~300MHz, FreqBegin=90.026855MHz, FreqResolution=0.076294MHz, Sensitivity=1SFU, DynamicRange>=60dB' )
    insertss.append('#DeviceState: N')
    insertss.append('#ObsParameters: AccuTime=0.838ms, FreqNum=2754')
    insertss.append('#Quantities: SFU')
    insertss.append('#Title: ' + titles )
    insertss.append('#UpSubgraphTitle: RCP')
    insertss.append('#MidSubgraphTitle: LCP')
    insertss.append('#DownSubgraphTitle: Soalr Radio Flux@245')
    
    strin=''
    for inss in insertss :
        strin = strin + inss + '\r\n' 
    bbstrin = strin.encode('utf-8')
    strlength = len( bbstrin ) + 2
    bstrlength = strlength.to_bytes(2, byteorder='big', signed = False )
       
    app15 = b'\xff\xef'
    
    fp = open(jpgname, mode='wb')
    #fp.write( bb[0:4] )
    fp.write( bb[0: int(4 + skipn)])
    fp.write( app15 )
    fp.write( bstrlength )
    fp.write( bbstrin )
    fp.write( bb[int(4 + skipn) ::] )
    fp.close()

    
    return jpgname, namefits



######==========================================================================
def getmd5fileone( fn ) :
### 
    file_md5 = ''
    with open(fn, 'rb') as fp:
         data = fp.read()
         file_md5 = hashlib.md5(data).hexdigest()

    return file_md5

def getmd5filemulti( fn, nbyte ) :
### 
    mdj = hashlib.md5()
    with open(fn, 'rb') as fp:
         data = fp.read( int(nbyte)  )
         mdj.update(data)     
         
    file_md5 =mdj.hexdigest()
    return file_md5

def uploadfile( fn, sharedir ) :
    endname = ''
    filemd5 = getmd5fileone( fn  )
    dirname = sharedir + filemd5 + '/'
    os.mkdir( dirname , 0o777 )
    outfilename = os.path.basename( fn )
    outfss = outfilename.split('.')
    copydone=0
    if len(outfss) > 2 :
        outfss[0]='.'.join(outfss[0:len(outfss)-1])
        
    try :
        tmpname = dirname + outfss[0] + '.tmp'
        endname = dirname + outfss[0] + '.' + outfss[-1]
        comds = 'cp ' + fn + ' ' + tmpname
        
        os.system(   comds )
        copydone=1
    except:
        print('copy failed' + fn )
    if copydone==1:   
    ## rename
        try :
            os.rename( tmpname, endname  )
        except:
            print('rename failled')
            endname = tmpname
    return endname

##### 目录类创建,确认存在
class dirmulu():
    def __init__( self, path ):
        self.path = path
        self.nfiles = 0
        self.fnames = []

    def waitexist(self, delayt=3600, sleept = 300 ):
        vstate = 1
        if self.path != '' :
            ### 确认数字采集 目录存在
            if os.path.exists(  self.path ) :
                vstate = 0
                print(  self.path + ' dir already creat ')
            else :
                tnows = datetime.datetime.now()
                print( tnows.isoformat() +  self.path +'is not exist!' )
                dtfind = datetime.datetime.now()  - tnows
                ### 搜索一个小时
                while True :
                   time.sleep( sleept )
                    ## 每个5分钟扫描目录是否创建
                   nows = datetime.datetime.now()
                   dtfind = nows  - tnows 
                   if  os.path.exists( self.path ) :
                       vstate = 0
                       print( nows.isoformat() + 'find the oridir' + self.path )
                       break
                   if dtfind.total_seconds() >  delayt :
                       
                       print('time is out , path is not exist!')
                       break
        return vstate
    def isexist(self):
        return os.path.exists( self.path )
    
    def waitFileIn(self,  subfix,  delayt=3600, sleept = 300 ) :
        fstate = 1
        jishi1 = time.time()
        jishi2 = time.time()
        while (jishi2 - jishi1 ) < delayt :
             fnx = file_search( self.path + subfix )
             if len( fnx ) > 0 :
                 if os.path.exists(fnx[0] ) :
                     fstate = 0
                     print(fnx)
                     break
             time.sleep( sleept ) 
             jishi2 = time.time()
        
        return fstate
    def filenum(self, subfix ):
        fnx = file_search( self.path + subfix )
        self.nfiles = len( fnx )
        self.fnames = fnx
        return self.nfiles
        
        


def getworkstat():
    obsstat={ " R1stat" : 0, " R2stat": 0, "objcc":"sun"  }
    
    
    
    
    ## obsstat 是一个字典
    return obsstat


def getworkstatfbin( ):
    ## obsstat 是一个字典
    
    obsstat={ "R1stat" : 0, "R2stat": 0, "objcc":"sun"  }
    return obsstat


def getlastfilenamest(   fnames ) :
    basename = os.path.basename( fnames )
    lastfilenametime = datetime.datetime( int( basename[14:18]), int( basename[18:20]),
     int( basename[20:22]), int( basename[23:25]), int( basename[25:27]),int( basename[27:29]) )
    return lastfilenametime
    

      

# def ADCsetP() :
##################################################=========================3
### 设备参数  ADC设置参数
### 2022-10-08 set
fftnum = 16*1024
fs = 1.25E9  ## Hz
ts = 1.0/fs  ## second 采样时间
et = fftnum *64*ts ## 积分时间 s
df = fs  / fftnum / 1E6   ## MHz
freq = np.arange( fftnum / 2 , dtype='>f8') * df ## MHz
freq = freq[0:8180] ##注意数据帧大小 截断高频
nfreq = len(freq)
index = np.where(freq > 90 )
findex1 = index[0][0]
index = np.where( freq >= 300 )
findex2 = index[0][0]
freqx = freq[findex1:findex2+1] 
nfreqx = len( freqx )

## 数据帧描述 ====== 几乎固定不动=============================================
sizehead = 2 ## 帧头标志符 2B 0x3C5A
sizenumb = 2 ## 帧记录数  2B  1-1024 
sizeswich= 1 ## 微波开关
sizesave = 3 ## 保留
sizedata = 8180 ## 数据长度 x2 字节数
sizetime = 8 ## 8B 时间戳 秒 分 时 保留 纳秒 x6.4
sizepwer = 4 ## 功率和
sizechan = 2 ## 通道标志符 CH1—0xFF_FF
sizetail = 2 ## 0x871E
####  little Endian 存储
sizeframe = sizehead + sizenumb + sizeswich + sizesave +  sizedata * 2 + sizetime 
sizeframe = sizeframe + sizepwer + sizechan + sizetail 
### 每帧数据类型
mydtype = np.dtype([('head','<u2'),('num','<u2'),('swich','u1'),('Bsav','S3'),('Rdata','(8180,)<u2'),('second','u1'),('minute','u1'),('hour','u1'),('kong','u1'),('nns','<u4'),('power','<u4'),('chID','S2'),('tail','S2')])


## chID 
ch0B = b'\xff\xff'  ## 表示通道1 可交换 修改
ch1B = b''  ## 表示通道1 
tailID = b'\x1e\x87'
swichID= 0 ###  正常观测 >0 定标状态
###################################################endendendendendend=========
## 考虑包间帧的时候可以使用
# np.frombuffer(s, dtype='S1', count=5, offset=6) 
# return 





###################读写函数==========================================
    
def read2datfitsjpg( fn, freq, df, et, findex1, findex2 , sdu=1, uploadv = 1, BJT2UTC = 28800, outdir = None ):
# if 1==1 :  
#  BJT2UTC = 8 * 3600 ###  UTC 使用世界统一时间
#
#
#
    nf = len( fn ) ## 文件数目
    ## get [year,month,day] from the first bin file name 北京时间
    datedd = datefromfname(fn[0])
    ### 创建子午数据的输出目录===============
    dateddss = '{:d}/{:02d}/{:d}{:02d}{:02d}/'.format(datedd[0],datedd[1],datedd[0],datedd[1],datedd[2])
    if outdir == None :
       outfitsdir = 'fits/'
    else :
       outfitsdir = outdir
        
    ### 判断输出目录存在是否并创建
    for dirss in [ outfitsdir ] :
       if os.path.exists(dirss) != True :
           print( 'creat dir ' + dirss )
           # os.makedirs( dirss )
           os.makedirs(dirss, mode=511, exist_ok = True )

    if sdu == 1 :
        ###创建sdu输出目录
        outfitsdirsdu = outfitsdir 

    freqx = freq[ findex1:int(findex2 + 1)]

    ##  input  fn  fn is filename list
    fnsize = np.array( [ os.path.getsize( fn[ii] ) for ii in range(nf) ] )
    ## move litte package
    index = np.where( fnsize < 16384 )
    if len(index[0] ) > 0 :
        for ii in index[0] :
            fn.remove( fn[ii] )
        nf = len(fn)    
        fnsize = np.array( [ os.path.getsize( fn[ii] ) for ii in range(nf) ] )
    
    headn  = np.array( [ getheadn( fn[ii] , sizeframe )  for ii in range(nf) ] )
    nfram =  np.array( [int( (fnsize[ii] - headn[ii] )/ sizeframe  )  for ii in range(nf) ] )
    
    ## 帧结束位置
    # tailn  = [int( headn[ii] + nfram[ii] * sizeframe )  for ii in range(nf) ] 
    tailn = headn  + nfram  * sizeframe   
    tailnB = fnsize - tailn  ## 剩余字节数
    ### 包间帧 字节数
    betweenBn = tailnB[0:nf-1] + headn[1:nf]
    setNt = np.sum( nfram ) // 2  + 2 * nf
    
    # # 检查包的有效性, 完整性检测===========

    
    #### 构造输出矩阵 === ==========================================
    ## 0 右旋 1 左旋 极化  需要确认
    oridataRL =  np.zeros( ( 2, nfreq, setNt ), dtype = 'u2')
    fitsdataRL = np.zeros( ( 2, nfreq, setNt ), dtype = '>f4')
    ttR = np.zeros(setNt, dtype = '>f8')
    ttL = np.zeros(setNt, dtype = '>f8')
    ### 注意 如果不解决帧丢失的问题 以及包间帧的选择问题
    ## ttR 与 ttL可能不等长，帧缺失造成不对齐
    nows = datetime.datetime.now()
    sysTime = nows.isoformat()[0:23]
    print(sysTime + ' start reading data from ADC computer...')
    Rnowtj = 0 ## 时间记录数
    Lnowtj = 0
    for ii in range(nf) :
        # 按格式逐个读入数据
        datafii = np.fromfile( fn[ii], dtype=mydtype, offset = headn[ii] )
        nrec = len(datafii)
        chii = datafii['chID']
        ##核查包的有效性====== 包间的帧 被放弃  
        headii = datafii['head']
        hindex = np.where( headii == 15450 )
        
        if len(hindex[0]) == nfram[ii] :
            # specii =np.transpose( datafii['Rdata'] , axes=(0,2,1) ).reshape( nrec , sizedata  )
            # specii =np.transpose( datafii['Rdata'] , axes=(0,2,1) ).reshape( nrec , sizedata  )
            specii = datafii['Rdata']
            ttii = np.double(  datafii['hour']*3600.0 +  datafii['minute'] * 60.0+  datafii['second'] +  datafii['nns'] * 6.4e-9  )
            indexch0 = np.where( chii == ch0B )
            indexch1 = np.where( chii == ch1B )
            nrecch0 =  len(indexch0[0])
            nrecch1 =  len(indexch1[0])
            
            startRj = Rnowtj
            startLj = Lnowtj
            Rnowtj += nrecch0
            Lnowtj += nrecch1
            
            oridataRL[0, :, startRj: Rnowtj] = specii[indexch0[0], :].T
            oridataRL[1, :, startLj: Lnowtj] = specii[indexch1[0], :].T
            ttR[ startRj: Rnowtj] = ttii[indexch0[0]]
            ttL[ startLj: Lnowtj] = ttii[indexch1[0]]
            ## log 
            print('000 ' +  fn[ii] + ' input all full package! ') 
        else :
            print('101 ' +  fn[ii] + ' find frame lost in package! ') 
            ##先 读入部分数据
            availn = hindex[0][-1]
            ## 判断 第 availn 的帧尾是否正确
            if chii[availn] == ch0B or chii[availn] == ch1B :
               nrec = int( availn + 1 )
            else :
               nrec = availn
    
            # specii =np.transpose( datafii[0:nrec]['Rdata'] , axes=(0,2,1) ).reshape( nrec , sizedata  )
            specii = datafii['Rdata']
            ttii = np.double(  datafii[0:nrec]['hour']*3600.0 +  datafii[0:nrec]['minute'] * 60.0+  datafii[0:nrec]['second'] +  datafii[0:nrec]['nns'] * 6.4e-9  )
            chii = chii[0:nrec]
            indexch0 = np.where( chii == ch0B )
            indexch1 = np.where( chii == ch1B )
            nrecch0 =  len(indexch0[0])
            nrecch1 =  len(indexch1[0])
            
            startRj = Rnowtj
            startLj = Lnowtj
            Rnowtj += nrecch0
            Lnowtj += nrecch1
            
            oridataRL[0, :, startRj: Rnowtj] = specii[indexch0[0], :].T
            oridataRL[1, :, startLj: Lnowtj] = specii[indexch1[0], :].T
            ttR[ startRj: Rnowtj] = ttii[indexch0[0]]
            ttL[ startLj: Lnowtj] = ttii[indexch1[0]]
            print('102 ' +  fn[ii] + ' first input {:d} records package! '.format(nrec) ) 
            offheadBfind =  headn[ii] + nrec * sizeframe
            if availn ==  nrec :               
                 offheadBfind =  offheadBfind + 2 

                    
            ## 考虑余下的部分,如果是在最后一帧断，则考虑放弃这一帧
            
            while (fnsize[ii] - offheadBfind ) >= ( sizeframe * 2 ) :
             ## 下一段表头位置 
              headnext = getheadnwhere(fn[ii] ,  sizeframe*2, offheadBfind  )
              if headnext != -1 :  
                if fnsize[ii] - headnext  >= sizeframe : 
                    datafii = np.fromfile( fn[ii], dtype=mydtype, offset = headnext )
                   ### 重复代码 考虑怎么合并
                   ##核查包的有效性====== 包间的帧 被放弃  
                    headii = datafii['head']
                    hindex = np.where( headii == 15450 )
                    availnj = hindex[0][-1]
                    chii = datafii['chID']
                    
                    ## 判断 第 availn 的帧尾是否正确
                    if chii[availnj] == ch0B or chii[availnj] == ch1B :
                       nrec = int( availnj + 1 )
                       offheadBfind = headnext  +   nrec * sizeframe
                       
                    else :
                       nrec = availnj
                       offheadBfind = headnext + nrec * sizeframe + 2
                       
                    
                    # specii =np.transpose( datafii[0:nrec]['Rdata'] , axes=(0,2,1) ).reshape( nrec , sizedata  )
                    specii = datafii['Rdata']
                    ttii = np.double(  datafii[0:nrec]['hour']*3600.0 +  datafii[0:nrec]['minute'] * 60.0+  datafii[0:nrec]['second'] +  datafii[0:nrec]['nns'] * 6.4e-9  )
                    chii = chii[0:nrec]
                    indexch0 = np.where( chii == ch0B )
                    indexch1 = np.where( chii == ch1B )
                    nrecch0 =  len(indexch0[0])
                    nrecch1 =  len(indexch1[0])
            
                    startRj = Rnowtj
                    startLj = Lnowtj
                    Rnowtj += nrecch0
                    Lnowtj += nrecch1
            
                    oridataRL[0, :, startRj: Rnowtj] = specii[indexch0[0], :].T
                    oridataRL[1, :, startLj: Lnowtj] = specii[indexch1[0], :].T
                    ttR[ startRj: Rnowtj] = ttii[indexch0[0]]
                    ttL[ startLj: Lnowtj] = ttii[indexch1[0]]
                    print('103 ' +  fn[ii] + ' next part input {:d} records package! offbyte ={:d} '.format(nrec, offheadBfind ) )  
                else:
                    break
              else : 
                offheadBfind +=  sizeframe*2
    #### 定标操作====================
    ##  由 oridataRL -- > fitsdataRL   所有的顶部程序在这里实现
    # oridataRL =  np.zeros( ( 2, nfreq, setNt ), dtype = 'u2')
    # 定标操作修改 定标修正函数  callibrationDon
    # fitsdataRL[:,:,:] = callibrationDon(  oridataRL  )
    datebj = datetime.datetime( datedd[0], datedd[1], datedd[2], 1, 0, 0 )
    if datebj > datetime.datetime(2025,3,13,1,0,0 ): 
         fitsdataRL[0,:,:] =    oridataRL[1,:,:]  * oridataRL[1,:,:]  
         fitsdataRL[1,:,:] =    oridataRL[0,:,:]  * oridataRL[0,:,:]   
    else :
         fitsdataRL[:,:,:] =  1.0 * oridataRL * oridataRL   
    
    
    
    
    
    
    ################################################################################
    
    
    ### out put ============================================
    chooseN = min( Rnowtj, Lnowtj)
    if Rnowtj == chooseN :
        ttt = ttR[0:chooseN]
    else :
        ttt = ttL[0:chooseN] 
    ## ttt 北京时间
    ######### 考虑 时间 跨越 天的情况 ======
    ### 数据包中出现跨天的情况 一般不会出现
    if ttt[0] > ttt[-1] :
        index = np.where( ttt < ttt[0] )
        ttt[index] +=  86400
        
    
    #####################################
    ## 从bin文件中获取观测状态==========================
    obsstate =  getworkstatfbin( )
    R1stat = obsstate['R1stat'] ##   0
    R2stat = obsstate['R2stat']
    ssobj =  obsstate[ 'objcc' ]
    nows = datetime.datetime.now()
    sysTime = nows.isoformat()[0:23]
    print( sysTime + ' creat data file')   

    if sdu == 1 :
        ### sdu data output
        # print('creat data file')   
        # namedatsdu = creatDatFile( ttt, oridataRL[:,:,0:chooseN].tobytes(),  outdatdirsdu, R1stat, R2stat, ssobj, datedd, BJT2UTC)
        
        nows = datetime.datetime.now()
        sysTime = nows.isoformat()[0:23]
        # outdir = 'G:/chashan/'
        print(sysTime + 'creat fits file for sdu') 
        namefitssdu = creatFitsFile(ttt, freq, fitsdataRL[:,:,0:chooseN] , df, et, datedd,  obsstate, outfitsdirsdu, BJT2UTC )
        print(namefitssdu)


    endTime = time.time()
    
    print(f"time = {endTime - startTime}")
    return 0 

##############################################################################



# if __name__ == '__main__':
#     fn = file_search('')
### 主程序代码部分


### 设定一次读入的 文件个数
Nfilein = 1
 

### 程序开始运行时间
todaynow = datetime.datetime.now()
todayss =  todaynow.strftime('%Y%m%d')
begin00 = datetime.datetime.fromisoformat(  todaynow.isoformat()[0:10]   )

# 当天存储原始数据目录
# oridir = MWRSoridir +todayss + '/'

oridir = '/home/data/SolarRadioData/CBSm/data/2024/01/20240110/20240110/'
outdirs = '/home/data/SolarRadioData/CBSm//data/2024/01/20240110/'
os.makedirs( outdirs, mode=511, exist_ok = True )
# oridir = '/home/data0/槎山数据/152046/'

# oridir = '/home/data0/槎山数据/120746/'
# oridir = MWRSoridir + '20221024' + '/'
### 考虑记录日志文件 ===
logfname = ''
nowsw = datetime.datetime.now()
sysTime = nowsw.isoformat()[0:23]

oridirpath = dirmulu( oridir)
### 确认数字采集 目录存在
fileexists = 1
if fileexists == 1 :
    ### cong n file begin
    kkfile = 0
    nfiles = oridirpath.filenum( 'CS*.bin')
    print('have {:d} files before is exist'.format(nfiles))
    #### 判断 目录 是不是昨天之前 创建的
    secondwhileout =  True 
    ## if probreak 
    # kkfile = 1070 ## 设置开始 bin 包
    # firstwhileout =1
    while True :
        ### 循环找到 符合时间要求的文件
        fnk = []  ### 记录 包
        nfnk = 0  ### 合成一个fits文件需要 包的个数 的 累加
        nfiles = oridirpath.filenum( 'CS*.bin')  
        while secondwhileout :
              print(nfiles , kkfile)
              if  nfnk == Nfilein :
                    ### 
                    read2datfitsjpg( fnk, freq, df, et, findex1, findex2, outdir=outdirs )
                    nfnk = 0
                    break
              fnk.append(  oridirpath.fnames[kkfile] )
              nfnk += 1
              kkfile += 1
              if kkfile == nfiles :
                  break
            
        if nfnk > 0 :
           read2datfitsjpg( fnk, freq, df, et, findex1, findex2,outdir=outdirs )
           nfnk = 0
           secondwhileout =  False 
           break
                        
                 


plt.close( "all" )
print(' today is done') 
os._exit(0)





















